
#include <stdio.h>
#include <stdlib.h>

#include <hip/hip_runtime.h>

#define hipErrorCheck(a) do { \
	if (hipSuccess != (a)) { \
		fprintf(stderr, "HIP runtime error in line %d of file %s \
			: %s \n", __LINE__, __FILE__, hipGetErrorString(a) ); \
		exit(EXIT_FAILURE); \
	} \
} while(0);

static void HandleError(hipError_t err, const char *file, int line)
{
	if (err != hipSuccess) {
		printf( "%s in %s at line %d\n", hipGetErrorString(err), file, line);
		exit( EXIT_FAILURE );
	}
}
#define HANDLE_ERROR(err) (HandleError(err, __FILE__, __LINE__ ))

#define HANDLE_NULL(a) {if (a == NULL) { \
	printf( "Host memory failed in %s at line %d\n", __FILE__, __LINE__ ); \
	exit( EXIT_FAILURE );}}



/* Host main routine */
int main(void)
{
	size_t numElements = 10;
	size_t size = numElements * sizeof(float);

	float *d_A = NULL;
	hipErrorCheck(hipMalloc((void **)&d_A, size));

	hipErrorCheck(hipFree(d_A));

    printf("Done\n");
    return 0;
}
